<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf, $user;

load_language('plugin.lang', CONCOURS_PATH);
include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
include_once(CONCOURS_PATH . 'admin/functions.inc.php');
$my_base_url = get_admin_plugin_menu_link(__FILE__);

// +-----------------------------------------------------------------------+
// |                            Tabsheet
// +-----------------------------------------------------------------------+
if (!isset($_GET['tab']))
    $page['tab'] = 'manage';
else
    $page['tab'] = $_GET['tab'];

$tabsheet = new tabsheet();
$tabsheet->add('manage',
               l10n('concours_management'),
               $my_base_url.'&amp;tab=manage');

$tabsheet->add('add_concours',
               l10n('concours_add'),
               $my_base_url.'&amp;tab=add_concours&amp;action=new');

$tabsheet->add('config',
               l10n('concours_config'),
               $my_base_url.'&amp;tab=config');

$tabsheet->add('params',
               l10n('concours_params'),
               $my_base_url.'&amp;tab=params');
/*
$tabsheet->add('audit',
               l10n('concours_audit'),
               $my_base_url.'&amp;tab=audit');
*/

$tabsheet->add('help',
               l10n('concours_help'),
               $my_base_url.'&amp;tab=help');

$tabsheet->select($page['tab']);
$tabsheet->assign();

if (isset($_GET['concours']))
{
    // Get informations from base for concours_id
    $concours = new Concours($_GET['concours']);
}


// Add informations from previous pages if present
if (isset($_GET['infos']) && isset($concours))
{
  $infos = $_GET['infos'];
  switch($infos)
  {
    case "0" :
    array_push($page['infos'],  sprintf( l10n('concours_saved'), $concours->concours_id, $concours->concours_infos['name']));
    break;

    }
}
            
$template->assign( 'CONCOURS_VERSION', l10n('concoursphoto')." (<i>Version ".CONCOURS_VERSION.'</i>)');


// Include file
include(CONCOURS_PATH.'admin/'.$page['tab'].'.php');

?>